Description

Hi, 

it seems a regression since 2.18.3, date edit widget will only show the current date in a form,  even without any default value set or being

readonly. 

This makes it pretty unusable.

I had hard time spotting it since another issue with qlr export #16655 let me think that only my project was corrupted.

History

#1 - 2017-06-02 05:05 AM - Nyall Dawson

- Status changed from Open to Feedback

That's a datetime field - I think the issue is that you've set the format to "date" along. Does it work correctly if you change that to "date/time"?

What data provider is this? can you share the data?

#2 - 2017-06-02 10:17 AM - Regis Haubourg

- File date_default_issue.gpkg added

That's a datetime field - I think the issue is that you've set the format to "date" along. Does it work correctly if you change that to "date/time"?

Nope, I tested many widget configuration changes before. Only setting it back to textEdit allowed me to see the actual data. 

What data provider is this? 

Original issue was detected in postgres with a view with edit triggers pointing to a table with a "timestamp with time zone" field. 

can you share the data?

Oh, I joined the wrong file.  Here is a gpkg file going with the date_default_widget_value_issue.qgs file

#3 - 2017-06-02 07:26 PM - Giovanni Manghi

- Status changed from Feedback to Open

#4 - 2017-06-15 04:18 PM - Regis Haubourg
when I cast the field in the SQL view to a date field, QGIS will handle it correctly.

#5 - 2017-09-06 11:40 AM - Denis Rouzaud

using yyyy-MM-dd HH:mm:ss+02 in the format solves the diplay issue.

The field format must be set accordingly to what is in the data, so it's not really a bug here.

Although I tried yyyy-MM-dd HH:mm:ss+t (time zone) without success. So there might be an issue here.

#6 - 2017-09-06 11:43 AM - Giovanni Manghi

- Status changed from Open to Feedback

#7 - 2017-09-06 11:45 AM - Denis Rouzaud

- Status changed from Feedback to Open

So I guess, there is two things to improve here:

    -  guessing the format from the source

    -  fix time zone format

#8 - 2017-09-06 11:47 AM - Giovanni Manghi

Denis Rouzaud wrote:

So I guess, there is two things to improve here:

    -  guessing the format from the source

    -  fix time zone format

the ticket has been tagged as a regression because apparently the guessing worked until 2.18.3

#9 - 2017-09-08 08:35 PM - Denis Rouzaud

- Assignee set to Denis Rouzaud

#10 - 2017-09-14 03:19 PM - Regis Haubourg

- Priority changed from High to Normal

Lowering the priority since casting to DATE format gives a workaround

#11 - 2017-09-26 11:57 AM - Giovanni Manghi

- Priority changed from Normal to High

Regis Haubourg wrote:
Lowering the priority since casting to DATE format gives a workaround

still a regression, so to keep consistency with the others better keep priority "high".

#12 - 2017-10-02 01:53 PM - Luigi Pirelli

error is probably only located in setting the correct format string here:

https://github.com/qgis/qgis/blob/release-2_18/src/gui/editorwidgets/qgsdatetimeeditfactory.cpp#L88

btw Qt:ISODate formate parse correctly the proposed date.

#13 - 2017-12-28 10:20 PM - Denis Rouzaud

https://github.com/qgis/QGIS/pull/5960

#14 - 2018-01-04 02:27 AM - Denis Rouzaud

fixed in master and 2.18

#15 - 2018-01-04 03:09 AM - Nyall Dawson

- Status changed from Open to Closed

#16 - 2018-02-22 11:21 AM - Giovanni Manghi

- Resolution set to fixed/implemented

Files

date_default_widget_value_issue.qgs 31 KB 2017-06-01 Regis Haubourg

test_date_constat.6.qgs 339 KB 2017-06-01 Regis Haubourg

Sélection_023.png 335 KB 2017-06-01 Regis Haubourg

date_default_issue.gpkg 52 KB 2017-06-02 Regis Haubourg
